import PropTypes from "prop-types";
import React from "react";
export declare const TIME_TO_CLOSE_MESSAGE = 3000;
export declare const DELAY_FOR_DBCLICK = 200;
export declare const CLICK_TO_CELL_EDIT = "click";
export declare const DBCLICK_TO_CELL_EDIT = "dbclick";
export declare const EDITTYPE: {
    TEXT: string;
    SELECT: string;
    TEXTAREA: string;
    CHECKBOX: string;
    DATE: string;
};
export interface CellEditProviderProps {
    data: any[];
    selectRow?: any;
    cellEdit: {
        options: {
            mode: string;
            onErrorMessageDisappear?: Function;
            blurToSave: boolean;
            beforeSaveCell: Function;
            afterSaveCell: Function;
            onStartEdit: Function;
            nonEditableRows: Function;
            timeToCloseMessage: number;
            errorMessage: any;
        };
    };
    keyField: string;
    children: any;
}
export interface CellEditProviderState {
    ridx: number | null;
    cidx: number | null;
    message: any;
}
declare const _default: (options?: {}) => {
    createContext: (_: any, dataOperator?: any, isRemoteCellEdit?: any, handleCellChange?: any) => {
        Provider: {
            new (props: any): {
                handleCellUpdate(row: any, column: any, newValue: any): void;
                doUpdate(row: any, column: any, newValue: any): void;
                completeEditing(): void;
                startEditing(ridx: any, cidx: any): void;
                escapeEditing(): void;
                render(): React.JSX.Element;
                context: unknown;
                setState<K extends keyof CellEditProviderState>(state: CellEditProviderState | ((prevState: Readonly<CellEditProviderState>, props: Readonly<CellEditProviderProps>) => CellEditProviderState | Pick<CellEditProviderState, K> | null) | Pick<CellEditProviderState, K> | null, callback?: (() => void) | undefined): void;
                forceUpdate(callback?: (() => void) | undefined): void;
                readonly props: Readonly<CellEditProviderProps>;
                state: Readonly<CellEditProviderState>;
                refs: {
                    [key: string]: React.ReactInstance;
                };
                componentDidMount?(): void;
                shouldComponentUpdate?(nextProps: Readonly<CellEditProviderProps>, nextState: Readonly<CellEditProviderState>, nextContext: any): boolean;
                componentWillUnmount?(): void;
                componentDidCatch?(error: Error, errorInfo: React.ErrorInfo): void;
                getSnapshotBeforeUpdate?(prevProps: Readonly<CellEditProviderProps>, prevState: Readonly<CellEditProviderState>): any;
                componentDidUpdate?(prevProps: Readonly<CellEditProviderProps>, prevState: Readonly<CellEditProviderState>, snapshot?: any): void;
                componentWillMount?(): void;
                UNSAFE_componentWillMount?(): void;
                componentWillReceiveProps?(nextProps: Readonly<CellEditProviderProps>, nextContext: any): void;
                UNSAFE_componentWillReceiveProps?(nextProps: Readonly<CellEditProviderProps>, nextContext: any): void;
                componentWillUpdate?(nextProps: Readonly<CellEditProviderProps>, nextState: Readonly<CellEditProviderState>, nextContext: any): void;
                UNSAFE_componentWillUpdate?(nextProps: Readonly<CellEditProviderProps>, nextState: Readonly<CellEditProviderState>, nextContext: any): void;
            };
            propTypes: {
                data: PropTypes.Validator<any[]>;
                selectRow: PropTypes.Requireable<object>;
                options: PropTypes.Requireable<PropTypes.InferProps<{
                    mode: PropTypes.Validator<string>;
                    onErrorMessageDisappear: PropTypes.Requireable<(...args: any[]) => any>;
                    blurToSave: PropTypes.Requireable<boolean>;
                    beforeSaveCell: PropTypes.Requireable<(...args: any[]) => any>;
                    afterSaveCell: PropTypes.Requireable<(...args: any[]) => any>;
                    onStartEdit: PropTypes.Requireable<(...args: any[]) => any>;
                    nonEditableRows: PropTypes.Requireable<(...args: any[]) => any>;
                    timeToCloseMessage: PropTypes.Requireable<number>;
                    errorMessage: PropTypes.Requireable<any>;
                }>>;
            };
            getDerivedStateFromProps(nextProps: any, prevState: any): {
                message: any;
                ridx?: undefined;
                cidx?: undefined;
            } | {
                ridx: any;
                cidx: any;
                message?: undefined;
            } | undefined;
            contextType?: React.Context<any> | undefined;
        };
    };
    createEditingCell: (_: any, onStartEdit?: any) => (props: any) => React.JSX.Element;
    withRowLevelCellEdit: (Component: any, selectRowEnabled: any) => {
        (props: any): React.JSX.Element;
        displayName: string;
    };
    DBCLICK_TO_CELL_EDIT: string;
    DELAY_FOR_DBCLICK: number;
    options: {};
};
export default _default;
export declare const Type: {
    TEXT: string;
    SELECT: string;
    TEXTAREA: string;
    CHECKBOX: string;
    DATE: string;
};
