"use strict";

var __importDefault = void 0 && (void 0).__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Type = exports.EDITTYPE = exports.DBCLICK_TO_CELL_EDIT = exports.CLICK_TO_CELL_EDIT = exports.DELAY_FOR_DBCLICK = exports.TIME_TO_CLOSE_MESSAGE = void 0;
var context_1 = __importDefault(require("./src/context"));
var editing_cell_consumer_1 = __importDefault(require("./src/editing-cell-consumer"));
var row_consumer_1 = __importDefault(require("./src/row-consumer"));
exports.TIME_TO_CLOSE_MESSAGE = 3000;
exports.DELAY_FOR_DBCLICK = 200;
exports.CLICK_TO_CELL_EDIT = "click";
exports.DBCLICK_TO_CELL_EDIT = "dbclick";
exports.EDITTYPE = {
  TEXT: "text",
  SELECT: "select",
  TEXTAREA: "textarea",
  CHECKBOX: "checkbox",
  DATE: "date"
};
exports["default"] = function () {
  var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  return {
    createContext: context_1["default"],
    createEditingCell: editing_cell_consumer_1["default"],
    withRowLevelCellEdit: row_consumer_1["default"],
    DBCLICK_TO_CELL_EDIT: exports.DBCLICK_TO_CELL_EDIT,
    DELAY_FOR_DBCLICK: exports.DELAY_FOR_DBCLICK,
    options: options
  };
};
exports.Type = exports.EDITTYPE;