"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }
function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }
var __rest = void 0 && (void 0).__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
var __importDefault = void 0 && (void 0).__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Consumer = void 0;
/* eslint react/prop-types: 0 */
/* eslint react/require-default-props: 0 */
/* eslint camelcase: 0 */
/* eslint react/no-unused-prop-types: 0 */
var prop_types_1 = __importDefault(require("prop-types"));
var react_1 = __importDefault(require("react"));
var __1 = require("..");
var CellEditContext = react_1["default"].createContext(null);
exports["default"] = function (_, dataOperator, isRemoteCellEdit, handleCellChange) {
  var CellEditProvider = /*#__PURE__*/function (_react_1$default$Comp) {
    _inherits(CellEditProvider, _react_1$default$Comp);
    var _super = _createSuper(CellEditProvider);
    function CellEditProvider(props) {
      var _this;
      _classCallCheck(this, CellEditProvider);
      _this = _super.call(this, props);
      _this.doUpdate = _this.doUpdate.bind(_assertThisInitialized(_this));
      _this.startEditing = _this.startEditing.bind(_assertThisInitialized(_this));
      _this.escapeEditing = _this.escapeEditing.bind(_assertThisInitialized(_this));
      _this.completeEditing = _this.completeEditing.bind(_assertThisInitialized(_this));
      _this.handleCellUpdate = _this.handleCellUpdate.bind(_assertThisInitialized(_this));
      _this.state = {
        ridx: null,
        cidx: null,
        message: null
      };
      return _this;
    }
    // eslint-disable-next-line consistent-return
    _createClass(CellEditProvider, [{
      key: "handleCellUpdate",
      value: function handleCellUpdate(row, column, newValue) {
        var _this2 = this;
        var newValueWithType = dataOperator.typeConvert(column.type, newValue);
        var cellEdit = this.props.cellEdit;
        var beforeSaveCell = cellEdit.options.beforeSaveCell;
        var oldValue = _.get(row, column.dataField);
        var beforeSaveCellDone = function beforeSaveCellDone() {
          var result = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : true;
          if (result) {
            _this2.doUpdate(row, column, newValueWithType);
          } else {
            _this2.escapeEditing();
          }
        };
        if (_.isFunction(beforeSaveCell)) {
          var result = beforeSaveCell(oldValue, newValueWithType, row, column, beforeSaveCellDone);
          if (_.isObject(result) && result.async) {
            return;
          }
        }
        this.doUpdate(row, column, newValueWithType);
      }
    }, {
      key: "doUpdate",
      value: function doUpdate(row, column, newValue) {
        var _this$props = this.props,
          keyField = _this$props.keyField,
          cellEdit = _this$props.cellEdit,
          data = _this$props.data;
        var afterSaveCell = cellEdit.options.afterSaveCell;
        var rowId = _.get(row, keyField);
        var oldValue = _.get(row, column.dataField);
        if (isRemoteCellEdit()) {
          handleCellChange(rowId, column.dataField, newValue);
        } else {
          dataOperator.editCell(data, keyField, rowId, column.dataField, newValue);
          if (_.isFunction(afterSaveCell)) {
            afterSaveCell(oldValue, newValue, row, column);
          }
          this.completeEditing();
        }
      }
    }, {
      key: "completeEditing",
      value: function completeEditing() {
        this.setState(function () {
          return {
            ridx: null,
            cidx: null,
            message: null
          };
        });
      }
    }, {
      key: "startEditing",
      value: function startEditing(ridx, cidx) {
        var _this3 = this;
        var editing = function editing() {
          _this3.setState(function () {
            return {
              ridx: ridx,
              cidx: cidx
            };
          });
        };
        var selectRow = this.props.selectRow;
        if (!selectRow || selectRow.clickToEdit || !selectRow.clickToSelect) {
          editing();
        }
      }
    }, {
      key: "escapeEditing",
      value: function escapeEditing() {
        this.setState(function () {
          return {
            ridx: null,
            cidx: null
          };
        });
      }
    }, {
      key: "render",
      value: function render() {
        var _a = this.props.cellEdit,
          _b = _a.options,
          nonEditableRows = _b.nonEditableRows,
          errorMessage = _b.errorMessage,
          optionsRest = __rest(_b, ["nonEditableRows", "errorMessage"]),
          cellEditRest = __rest(_a, ["options"]);
        var newCellEdit = Object.assign(Object.assign(Object.assign(Object.assign({}, optionsRest), cellEditRest), this.state), {
          nonEditableRows: _.isDefined(nonEditableRows) ? nonEditableRows() : [],
          onStart: this.startEditing,
          onEscape: this.escapeEditing,
          onUpdate: this.handleCellUpdate
        });
        return react_1["default"].createElement(CellEditContext.Provider, {
          value: Object.assign({}, newCellEdit)
        }, this.props.children);
      }
    }], [{
      key: "getDerivedStateFromProps",
      value: function getDerivedStateFromProps(nextProps, prevState) {
        if (nextProps.cellEdit && _.isFunction(isRemoteCellEdit) && isRemoteCellEdit()) {
          if (nextProps.cellEdit.options.errorMessage) {
            return {
              message: nextProps.cellEdit.options.errorMessage
            };
          } else {
            return {
              ridx: prevState.ridx,
              cidx: prevState.cidx
            };
          }
        }
      }
    }]);
    return CellEditProvider;
  }(react_1["default"].Component);
  CellEditProvider.propTypes = {
    data: prop_types_1["default"].array.isRequired,
    selectRow: prop_types_1["default"].object,
    options: prop_types_1["default"].shape({
      mode: prop_types_1["default"].oneOf([__1.CLICK_TO_CELL_EDIT, __1.DBCLICK_TO_CELL_EDIT]).isRequired,
      onErrorMessageDisappear: prop_types_1["default"].func,
      blurToSave: prop_types_1["default"].bool,
      beforeSaveCell: prop_types_1["default"].func,
      afterSaveCell: prop_types_1["default"].func,
      onStartEdit: prop_types_1["default"].func,
      nonEditableRows: prop_types_1["default"].func,
      timeToCloseMessage: prop_types_1["default"].number,
      errorMessage: prop_types_1["default"].any
    })
  };
  return {
    Provider: CellEditProvider
  };
};
exports.Consumer = CellEditContext.Consumer;