"use strict";

var __importDefault = void 0 && (void 0).__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};
Object.defineProperty(exports, "__esModule", {
  value: true
});
/* eslint react/prop-types: 0 */
var react_1 = __importDefault(require("react"));
var context_1 = require("./context");
var editing_cell_1 = __importDefault(require("./editing-cell"));
exports["default"] = function (_, onStartEdit) {
  var EditingCell = (0, editing_cell_1["default"])(_, onStartEdit);
  var renderWithEditingCell = function renderWithEditingCell(props, cellEdit) {
    var content = _.get(props.row, props.column.dataField);
    var editCellstyle = props.column.editCellStyle || {};
    var editCellclasses = props.column.editCellClasses;
    if (_.isFunction(props.column.editCellStyle)) {
      editCellstyle = props.column.editCellStyle(content, props.row, props.rowIndex, props.columnIndex);
    }
    if (_.isFunction(props.column.editCellClasses)) {
      editCellclasses = props.column.editCellClasses(content, props.row, props.rowIndex, props.columnIndex);
    }
    return react_1["default"].createElement(EditingCell, Object.assign({}, props, {
      className: editCellclasses,
      style: editCellstyle
    }, cellEdit));
  };
  return function (props) {
    return react_1["default"].createElement(context_1.Consumer, null, function (cellEdit) {
      return renderWithEditingCell(props, cellEdit);
    });
  };
};