"use strict";

var __importDefault = void 0 && (void 0).__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};
Object.defineProperty(exports, "__esModule", {
  value: true
});
/* eslint react/prop-types: 0 */
var react_1 = __importDefault(require("react"));
var __1 = require("..");
var context_1 = require("./context");
exports["default"] = function (Component, selectRowEnabled) {
  var renderWithCellEdit = function renderWithCellEdit(props, cellEdit) {
    var key = props.value;
    var editableRow = !(cellEdit.nonEditableRows.length > 0 && cellEdit.nonEditableRows.indexOf(key) > -1);
    var attrs = {};
    if (selectRowEnabled && cellEdit.mode === __1.DBCLICK_TO_CELL_EDIT) {
      attrs.DELAY_FOR_DBCLICK = __1.DELAY_FOR_DBCLICK;
    }
    return react_1["default"].createElement(Component, Object.assign({}, props, attrs, {
      editingRowIdx: cellEdit.ridx,
      editingColIdx: cellEdit.cidx,
      editable: editableRow,
      onStart: cellEdit.onStart,
      clickToEdit: cellEdit.mode === __1.CLICK_TO_CELL_EDIT,
      dbclickToEdit: cellEdit.mode === __1.DBCLICK_TO_CELL_EDIT
    }));
  };
  function withConsumer(props) {
    return react_1["default"].createElement(context_1.Consumer, null, function (cellEdit) {
      return renderWithCellEdit(props, cellEdit);
    });
  }
  withConsumer.displayName = "WithCellEditingRowConsumer";
  return withConsumer;
};